<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
	<title>BootStrap-Flex</title>
</head>

<body>

	<div class="container-fluid text-center">
		<h1>Bootstrap Flex</h1>
		<p>Use the d-flex class to create a flex container and transform direct children into flex items</p>

		<h2>Centering Elements</h2>
		<!-- d-flex - the flex value will change the element into block-level container. It will make all the child elements to become flexible that allows them to occupy space enough for the content of an element and the same time will have the elements appear beside each other -->

		<!-- justify-content-center - it will horizontally enter all child elements and it will only be accessible if the display value is flex. -->

		<!-- align-items-center class with vertically center all the child elements. Same with justify-content-center it is only accessible if the display value is flex. -->

		<!-- flex-column - this class will display elements on top of each other -->

		<!-- flex-reverse-column it will display the elements vertically starting from the last div -->
		<div style="height: 500px;" class="bg-dark p-3 d-flex justify-content-center align-items-center flex-column">
			<div class="p-3 bg-success col-2">Flex Item A</div>
			<div class="p-3 bg-warning col-2">Flex Item B</div>
			<div class="p-3 bg-danger col-2">Flex Item C</div>
		</div>

		<h2>Flex Row</h2>
		<!-- flex-row changes how the elements display horizontally -->
		<div class="bg-dark p-3 d-flex flex-row">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flow Row Reverse</h2>
		<div class="bg-dark p-3 d-flex flex-row-reverse">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Creating Space Between Elements</h2>
		<!-- d-md-flex class will apply flex values to the display property on a medium screen and higher -->

		<!-- the justify-content-around class may only be applied if the element has a flex value. it centers elements horizontally while creating space between elements and the borders of its parent container -->
		<div class="p-3 bg-dark d-md-flex justify-content-around">
			<div class="p-3 bg-success col-md-2">Flex Item A</div>
			<div class="p-3 bg-warning col-md-2">Flex Item B</div>
			<div class="p-3 bg-danger col-md-2">Flex Item C</div>
		</div>

		<h2>Flexbox with margin</h2>
		<!-- mr-auto class will occupy the remaining width of its parent container pushing all the other elements inline -->
		<div class="bg-dark p-3 d-flex">
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
			<div class="p-3 bg-primary">Flex Item D</div>
		</div>

		<h2>Nested Flex Elements</h2>
		<div class="bg-dark p-3 d-md-flex">
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			<div class="d-md-flex justify-content-between w-50">
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
				<div class="p-3 bg-primary">Flex Item D</div>
			</div>
		</div>

	</div>

	



	<!-- Bootstrap script -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
</body>
</html>